<script lang="ts">
import { PropType } from "vue";
import { defineComponent } from "vue";

import { defaultSettings, validPlayerCounts } from "../settings";

export default defineComponent({
  data(vm) {
    return {
      settings: vm.initialSettings,
      readonly: vm.initialReadonly,
      validPlayerCounts,
    };
  },
  methods: {
    handlePlayerCountChange() {
      this.onChange(this.settings);
    },
  },
  props: {
    initialSettings: {
      type: Object as PropType<GameSettings>,
      default: defaultSettings,
    },
    initialReadonly: {
      type: Boolean,
      default: false,
    },
    onChange: {
      type: Function as PropType<(settings: GameSettings) => void>,
      required: true,
    },
  },
});
</script>

<template>
  <section>
    <fieldset>
      <legend>Player counts</legend>

      <ul>
        <li v-for="c in validPlayerCounts">
          <label class="player-count" :for="`player-count-${c}`">
            <input
              :id="`player-count-${c}`"
              type="checkbox"
              :checked="settings.playerCounts.includes(c)"
              v-on:change="handlePlayerCountChange"
              v-model="settings.playerCounts"
              :value="c"
              :disabled="readonly"
            />
            {{ c }}
          </label>
        </li>
      </ul>
      <ul>
        <li><small>Recommended: 2-4</small></li>
        <li><small>Best: 3</small></li>
      </ul>
    </fieldset>
  </section>
</template>

<style scoped>
section {
  padding-bottom: 1rem;
  display: grid;
  row-gap: 1em;
}

fieldset {
  border: 0;
  padding: 0;
  margin: 0;
}
legend {
  padding: 0;
}
ul {
  margin: 0;
  display: flex;
  flex-wrap: wrap;
  column-gap: 1em;
}
li {
  white-space: nowrap;
}

small {
  filter: opacity(90%);
}
</style>
